# modes.h File Reference

Describes the different modes of the codec. More...

`#include <speex/speex.h>`
`#include <speex/speex_bits.h>`
`#include "arch.h"`

## Classes

struct | SpeexSubmode
struct | SpeexNBMode
struct | SpeexSBMode

## Defines

#define | SPEEX_GET_PI_GAIN 100
#define | SPEEX_GET_EXC 101
#define | SPEEX_GET_INNOV 102
#define | SPEEX_GET_DTX_STATUS 103
#define | SPEEX_SET_INNOVATION_SAVE 104
#define | SPEEX_SET_WIDEBAND 105
#define | SPEEX_GET_STACK 106

## Typedefs

typedef void(* | lsp_quant_func )(spx_lsp_t *, spx_lsp_t *, int, SpeexBits *)
typedef void(* | lsp_unquant_func )(spx_lsp_t *, int, SpeexBits *)
typedef int(* | ltp_quant_func )(spx_word16_t *, spx_word16_t *, spx_coef_t *, spx_coef_t *, spx_coef_t *, spx_sig_t *, const void *, int, int, spx_word16_t, int, int, SpeexBits *, char *, spx_word16_t *, spx_word16_t *, int, int, int, spx_word32_t *)
typedef void(* | ltp_unquant_func )(spx_word16_t *, spx_word32_t *, int, int, spx_word16_t, const void *, int, int *, spx_word16_t *, SpeexBits *, char *, int, int, spx_word16_t, int)
typedef void(* | innovation_quant_func )(spx_word16_t *, spx_coef_t *, spx_coef_t *, spx_coef_t *, const void *, int, int, spx_sig_t *, spx_word16_t *, SpeexBits *, char *, int, int)
typedef void(* | innovation_unquant_func )(spx_sig_t *, const void *, int, SpeexBits *, char *, spx_int32_t *)

## Detailed Description

Describes the different modes of the codec.

## Define Documentation

#define SPEEX_GET_DTX_STATUS 103

Used internally

#define SPEEX_GET_EXC 101

Used internally

#define SPEEX_GET_INNOV 102

Used internally

#define SPEEX_GET_PI_GAIN 100

Used internally

#define SPEEX_GET_STACK 106

Used internally

#define SPEEX_SET_INNOVATION_SAVE 104

Used internally

#define SPEEX_SET_WIDEBAND 105

Used internally

## Typedef Documentation

typedef void(* innovation_quant_func)(spx_word16_t *, spx_coef_t *, spx_coef_t *, spx_coef_t *, const void *, int, int, spx_sig_t *, spx_word16_t *, SpeexBits *, char *, int, int)

Innovation quantization function

typedef void(* innovation_unquant_func)(spx_sig_t *, const void *, int, SpeexBits *, char *, spx_int32_t *)

Innovation unquantization function

typedef void(* lsp_quant_func)(spx_lsp_t *, spx_lsp_t *, int, SpeexBits *)

Quantizes LSPs

typedef void(* lsp_unquant_func)(spx_lsp_t *, int, SpeexBits *)

Decodes quantized LSPs

typedef int(* ltp_quant_func)(spx_word16_t *, spx_word16_t *, spx_coef_t *, spx_coef_t *, spx_coef_t *, spx_sig_t *, const void *, int, int, spx_word16_t, int, int, SpeexBits *, char *, spx_word16_t *, spx_word16_t *, int, int, int, spx_word32_t *)

Long-term predictor quantization

typedef void(* ltp_unquant_func)(spx_word16_t *, spx_word32_t *, int, int, spx_word16_t, const void *, int, int *, spx_word16_t *, SpeexBits *, char *, int, int, spx_word16_t, int)

Long-term un-quantize